object JSON1 {
  // Data  
  case class Person(names: List[String], age: Int)

  // JSON Conversion
  sealed trait ToJSON[T] {
    def apply(in: T): String
  }

  //class ToJSON t where
  //  apply :: t -> String


  object ToJSON {
    def apply[T](f: T => String): ToJSON[T] = new ToJSON[T] {
      def apply(in: T) = f(in)
    }
  }

  def toJSON[T](t: T)(implicit toJSON: ToJSON[T]) = toJSON(t)
  // toJSON :: ToJSON t => t -> String
  // toJSON = apply

  implicit val stringToJSON = 
    ToJSON[String]('"' + _ + '"') // Will break with escapes

  // instance ToJSON String where
  //   apply s = '"' : s ++ ['"']

  implicit val intToJSON = 
    ToJSON[Int](_.toString)

  implicit def listToJSON[T](implicit toJSON: ToJSON[T]) = 
    ToJSON[List[T]](l => l.map(toJSON(_)).mkString("[",",","]"))

  implicit val personToJSON = 
    ToJSON[Person](p =>
    s"""|{
        |  "constructor": "Person",
        |  "names": ${toJSON(p.names)},
        |  "age": ${toJSON{p.age}}
        |}""".stripMargin)
}